//*****************************************************************************
//!
//! @file $Id: pll_drv.h 804 2008-02-20 09:09:20Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief 啔 : PLLgpϸۖ߂܂͊֐񋟂܂B
//!
//! @todo
//! @bug
//*****************************************************************************

#ifndef PLL_DRV_H
#define PLL_DRV_H

//_____ ݸٰ _______________________________________________________________

//! @defgroup PLL_module PLL
//! PLL
//! @{
//_____ ϸ ___________________________________________________________________

  //! @defgroup PLL_macros PLLϸ
  //! ̊֐PLL̐܂B
  //! @{

#define Start_pll_64_mega()		(PLLCSR = 0x06)					//!< 64MHzPLLJn
#define Start_pll_32_mega()		(PLLCSR = 0x02)					//!< 32MHzPLLJn
#define Start_pll(frequency)	\								//! Ұg(32܂64MHẑ)PLLJn
		(PLLCSR = ( (((frequency>>6)&1)<<2) | (1<<1) ) )
#define Is_pll_ready()			(PLLCSR & (1<<PLOCK) )			//!< PLL1Ԃ܂B
#define Wait_pll_ready()		while (!(PLLCSR & (1<<PLOCK)))
#define Stop_pll()				(PLLCSR = 0x00)					//!< PLL~

  //! @}

//_____ ` __________________________________________________________________

//_____ ֐ __________________________________________________________________

//! @}
#endif  // PLL_DRV_H
